# Sprachschulsystem

*PA165 course project at FI MUNI Spring 2023.*

# About Project

- **Name**: Language school
- **Technologies**: Java 17, Spring, Maven, ...
- **Developers**:
    - Dominika Zemanovičová *@xzemanov*
    - Martin Gargalovič *@xgargal*
    - Jan Pokorný *@xpokorn8*
    - Ester Vilímková - _Project Leader_ *@xvilimk*


- **Assigment**:
    - Create a system for language school lecture management. Each lecture can occur on a given day and time and is related to some course. The course is defined by its (unique) name, language and proficiency level. However, each lecture will be independent. That means that each lecture can have a different topic. Different lecturers can give it, and an arbitrary number of students can enrol. Each lecturer will have a name, surname, and record of taught languages. In addition, the lecturer will indicate that they are a native speaker. Exercises can be prepared for each course to allow the students to learn the language. Each student can pick the exercises depending on the levels of difficulty.


- **Running the modules using docker-compose**:

    ```console
    cd ./application
    mvn clean install
    docker-compose build --parallel
    docker-compose up
    ```

- **Running the modules using podman-compose**:
    ~~~console
    cd ./application
    mvn clean install
    podman-compose build --parallel
    podman-compose up
    ~~~

- **Running the modules using docker**:
    ~~~console
   sudo docker run -d -p 5001:5001 xpokorn8/sprachschulsystem:certificate &&
   sudo docker run -d -p 5002:5002 xpokorn8/sprachschulsystem:exercise &&
   sudo docker run -d -p 5000:5000 xpokorn8/sprachschulsystem:language-school &&
   sudo docker run -d -p 5003:5003 xpokorn8/sprachschulsystem:mail
    ~~~


# Project Description

Sprachschulsystem is a web-based application that aims to simplify and streamline the management of language school lectures. The system is designed to provide an easy-to-use interface that allows language schools to manage lectures, courses, lecturers, exercises, and students.

## Roles

System has three authorization roles - **Lecturer**,  **Student** and **Admin**.

## Module services

- **module-language-school**
- **module-certificate**
- **module-exercice**
- **module-mail**

# Diagrams

DTO Class Diagram:
![Class Diagram](https://gitlab.fi.muni.cz/xpokorn8/sprachschulsystem/-/raw/main/docs/ClassDiagram.png)

---

Use-case Diagram:
![UseCase Diagram](https://gitlab.fi.muni.cz/xpokorn8/sprachschulsystem/-/raw/main/docs/UseCaseDiagram.png)
