package org.fuseri.model.dto.user;

import jakarta.validation.Valid;
import jakarta.validation.constraints.NotBlank;
import jakarta.validation.constraints.NotNull;
import lombok.EqualsAndHashCode;
import org.fuseri.model.dto.common.DomainObjectDto;
import lombok.Getter;
import lombok.Setter;
import org.fuseri.model.dto.course.LanguageTypeDto;
import org.fuseri.model.dto.course.ProficiencyLevelDto;

import java.util.Map;

@Getter
@Setter
@EqualsAndHashCode(callSuper = false)
public class UserDto extends DomainObjectDto {

    @NotBlank
    private String username;

    @NotBlank
    private String email;

    @NotBlank
    private String firstName;

    @NotBlank
    private String lastName;
    
    @Valid
    private AddressDto address;

    @NotNull
    private UserType userType;

    @NotNull
    @Valid
    private Map<LanguageTypeDto, ProficiencyLevelDto> languageProficiency;

    public UserDto(String username, String email, String firstName, String lastName, AddressDto address, UserType userType) {
        this.username = username;
        this.email = email;
        this.firstName = firstName;
        this.lastName = lastName;
        this.address = address;
        this.userType = userType;
    }
}
