package org.fuseri.moduleexercise.answer;

import org.fuseri.moduleexercise.common.DomainRepository;
import org.springframework.data.repository.query.Param;

import java.util.List;

/**
 * A repository interface for managing Answer entities
 */
public interface AnswerRepository extends DomainRepository<Answer, String> {

    /**
     * Find all answers to a question with the specified ID
     *
     * @param questionId the ID of the question to find answers for
     * @return a list of all answers to the specified question
     */
    List<Answer> findByQuestionId(@Param("questionId") String questionId);
}