package org.fuseri.modulelanguageschool.course;

import jakarta.persistence.*;
import lombok.*;
import org.fuseri.modulelanguageschool.common.DomainObject;
import org.fuseri.modulelanguageschool.user.User;

import java.util.Set;

@Getter
@Setter
@Entity
@Table(name = "course")
@NoArgsConstructor
@AllArgsConstructor
public class Course extends DomainObject {

    private String name;
    private Integer capacity;

    @Enumerated(EnumType.STRING)
    private Language language;

    @Enumerated(EnumType.STRING)
    private ProficiencyLevel proficiency;

    @ManyToMany
    private Set<User> students;

    private boolean finished = false;
    public void enrolStudent(User student) {
        students.add(student);
    }

    public void expelStudent(User student) {
        students.remove(student);
    }

    public Course(String name, Integer capacity, Language language, ProficiencyLevel proficiency) {
        this.name = name;
        this.capacity = capacity;
        this.language = language;
        this.proficiency = proficiency;
    }

    public void setFinished(boolean finished) {
        this.finished = finished;
    }
}
